package com.anren.omplayer;

import android.webkit.CookieSyncManager;
import com.facebook.react.ReactPackage;
import com.facebook.react.bridge.JavaScriptModule;
import com.facebook.react.bridge.NativeModule;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.uimanager.ViewManager;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * Created by lcg on 2017/6/15.
 */

public class OMPlayerPackage implements ReactPackage {

    @Override
    public List<NativeModule> createNativeModules(ReactApplicationContext reactContext) {
        return Arrays.<NativeModule>asList(
                new OMAudioPlayerModule(reactContext),
                new OMVideoPlayerModule(reactContext),
                new OMAudioPlayerModuleTc(reactContext),
                new OMAudioPlayerModuleIjk(reactContext)
        );
    }

    @Override
    public List<Class<? extends JavaScriptModule>> createJSModules() {
        return Collections.emptyList();
    }

    @Override
    public List<ViewManager> createViewManagers(ReactApplicationContext reactContext) {
        CookieSyncManager.createInstance(reactContext);
        return Arrays.<ViewManager>asList(new OMVideoViewManager(), new OMVideoViewManagerTc());
    }
}
